.486                      ; create 32 bit code
.model flat, stdcall      ; 32 bit memory model
option casemap :none      ; case sensitive
include \masm32\include\windows.inc
include \masm32\macros\macros.asm
include \masm32\macros\ucmacros.asm
include \masm32\macros\windows.asm

UNICODE_STRING STRUCT
    xLength dw ?
    MaximumLength dw ?
    Buffer dd ?
UNICODE_STRING ENDS

RTL_DRIVE_LETTER_CURDIR STRUCT
    Flags dw ?
    xLength dw ?
    TimeStamp dd ?
    DosPath UNICODE_STRING <>
RTL_DRIVE_LETTER_CURDIR ENDS

PRTL_DRIVE_LETTER_CURDIR equ <dd>

PEB_LDR_DATA STRUCT 4
    xLength dd ?
    Initialized db ?
    SsHandle dd ?
    InLoadOrderModuleList LIST_ENTRY <>
    InMemoryOrderModuleList LIST_ENTRY <>
    InInitializationOrderModuleList LIST_ENTRY <>
PEB_LDR_DATA ENDS

RTL_USER_PROCESS_PARAMETERS STRUCT
    MaximumLength dd ?
    xLength dd ?
    Flags dd ?
    DebugFlags dd ?
    ConsoleHandle dd ?
    ConsoleFlags dd ?
    StdInputHandle dd ?
    StdOutputHandle dd ?
    StdErrorHandle dd ?
    CurrentDirectoryPath UNICODE_STRING <>
    CurrentDirectoryHandle dd ?
    DllPath UNICODE_STRING <>
    ImagePathName UNICODE_STRING <>
    CommandLine UNICODE_STRING <>
    Environment dd ?
    StartingPositionLeft dd ?
    StartingPositionTop dd ?
    xWidth dd ?
    Height dd ?
    CharWidth dd ?
    CharHeight dd ?
    ConsoleTextAttributes dd ?
    WindowFlags dd ?
    ShowWindowFlags dd ?
    WindowTitle UNICODE_STRING <>
    DesktopName UNICODE_STRING <>
    ShellInfo UNICODE_STRING <>
    RuntimeData UNICODE_STRING <>
    DLCurrentDirectory dd 20h dup(?)
RTL_USER_PROCESS_PARAMETERS ENDS

PEB_FREE_BLOCK STRUCT
    Next dd ?
    xSize dd ?
PEB_FREE_BLOCK ENDS

PEB STRUCT
    InheritedAddressSpace db ?
    ReadImageFileExecOptions db ?
    BeingDebugged db ?
    Spare db ?
    Mutant dd ?
    ImageBaseAddress dd ?
    LoaderData dd ?
    ProcessParameters dd ?
    SubSystemData dd ?
    ProcessHeap dd ?
    FastPebLock dd ?
    FastPebLockRoutine dd ?
    FastPebUnlockRoutine dd ?
    EnvironmentUpdateCount dd ?
    KernelCallbackTable dd ?
    EventLogSection dd ?
    EventLog dd ?
    FreeList dd ?
    TlsExpansionCounter dd ?
    TlsBitmap dd ?
    TlsBitmapBits dd 2 dup(?)
    ReadOnlySharedMemoryBase dd ?
    ReadOnlySharedMemoryHeap dd ?
    ReadOnlyStaticServerData dd ?
    AnsiCodePageData dd ?
    OemCodePageData dd ?
    UnicodeCaseTableData dd ?
    NumberOfProcessors dd ?
    NtGlobalFlag dd ?
    Spare2 db 4 dup(?)
    CriticalSectionTimeout dq ?
    HeapSegmentCommit dd ?
    HeapDeCommitTotalFreeThreshold dd ?
    HeapDeCommitFreeBlockThreshold dd ?
    NumberOfHeaps dd ?
    MaximumNumberOfHeaps dd ?
    ProcessHeaps dd ?
    GdiSharedHandleTable dd ?
    ProcessStarterHelper dd ?
    GdiDCAttributeList dd ?
    LoaderLock dd ?
    OSMajorVersion dd ?
    OSMinorVersion dd ?
    OSBuildNumber dd ?
    OSPlatformId dd ?
    ImageSubSystem dd ?
    ImageSubSystemMajorVersion dd ?
    ImageSubSystemMinorVersion dd ?
    GdiHandleBuffer dd 22h dup(?)
    PostProcessInitRoutine dd ?
    TlsExpansionBitmap dd ?
    TlsExpansionBitmapBits db 80h dup(?)
    SessionId dd ?
PEB ENDS

LDR_MODULE STRUCT
    InLoadOrderModuleList LIST_ENTRY <>
    InMemoryOrderModuleList LIST_ENTRY <>
    InInitializationOrderModuleList LIST_ENTRY <>
    BaseAddress dd ?
    EntryPoint dd ?
    SizeOfImage dd ?
    FullDllName UNICODE_STRING <>
    BaseDllName UNICODE_STRING <>
    Flags dd ?
    LoadCount dw ?
    TlsIndex dw ?
    HashTableEntry LIST_ENTRY <>
    TimeDateStamp dd ?
LDR_MODULE ENDS

chrW$ MACRO any_text:VARARG
  LOCAL txtname
  .data
    align 2
    WSTR txtname,any_text
  .code
  EXITM <OFFSET txtname>
ENDM

chrW2$ MACRO any_text:VARARG
  LOCAL txtname
  .data
    align 2
    $$$ZSTRINGW txtname,any_text
  .code
  EXITM <OFFSET txtname>
ENDM

xinvoke MACRO name:REQ, params:VARARG
	count = 0
	FOR xparam, <params>
	    count = count + 1
	    @CatStr(var,%count) TEXTEQU @CatStr(&xparam)
	ENDM

	REPEAT count
	    push @CatStr(var,%count)
	    count = count - 1
	ENDM

	mov eax,name
	call eax
ENDM

COMPRESSION_FORMAT_LZNT1 = 2h

comment!
NTSTATUS RtlDecompressBuffer(
  __in   USHORT CompressionFormat,
  __out  PUCHAR UncompressedBuffer,
  __in   ULONG UncompressedBufferSize,
  __in   PUCHAR CompressedBuffer,
  __in   ULONG CompressedBufferSize,
  __out  PULONG FinalUncompressedSize
);
!

.code
start:

;Push return address of our function
;Later it will be rewritten with actual PE entry point address
push 99999999h
;Jump to unpacker function
jmp short mainfunc
;int 3
;nop

;Unpacker function
mainfunc PROC
  ;Some local addresses of GetProcAddress(), LoadLibraryA(), RtlDecompress(),
  ;VirtualAlloc(), VirtualProtect(), VirtualFree() WinAPI functions
  LOCAL GetProcAddressFunc :DWORD
  LOCAL LoadLibraryAFunc :DWORD
  LOCAL RtlDecompressBufferFunc :DWORD
  LOCAL VirtualAllocFunc :DWORD
  LOCAL VirtualProtectFunc :DWORD
  LOCAL VirtualFreeFunc :DWORD
  
  ;Addresses of kernel32 and ntdll libraries
  LOCAL krnl :DWORD
  LOCAL ntdll :DWORD
  
  
  ;Buffers to handle names of GetProcAddress, LoadLibraryA, RtlDecompress,
  ;VirtualAlloc, VirtualProtect, VirtualFree and ntdll.dll
  LOCAL GetProcAddressName[16] :BYTE
  LOCAL LoadLibraryAName[16] :BYTE
  LOCAL RtlDecompressBufferName[24] :BYTE
  LOCAL ntdllName[16] :BYTE
  LOCAL VirtualAllocName[16] :BYTE
  LOCAL VirtualFreeName[16] :BYTE
  LOCAL VirtualProtectName[16] :BYTE
  
  
  ;PE info
  ;Import Table
  LOCAL IAT: DWORD
  
  ;Support for up to 16 sections
  ;Section virtual addresses
  LOCAL sect_VA[16] :DWORD
  ;Compressed section sizes
  LOCAL sect_size[16] :DWORD
  ;Decompressed section sizes
  LOCAL sect_size_original[16] :DWORD
  ;Section attributes
  LOCAL sect_attrs[16] :DWORD
  
  ;Image Base
  LOCAL image_base :DWORD
  
  ;TLS index of packed exe and TLS original index
  LOCAL tls_index :DWORD
  LOCAL tls_orig_index :DWORD
  
  ;Some temporary variables
  LOCAL old_prot :DWORD
  LOCAL tempbuf :DWORD
  LOCAL tempparam :DWORD
  
  ;Original image base (used if fixups are present)
  LOCAL original_image_base :DWORD
  
  ;Original fixup table address
  LOCAL fixup_table :DWORD
  
  ;actual image base
  LOCAL fixed_image_base :DWORD
  
  ;Actual resource section data
  LOCAL res_data_dir_addr :DWORD
  LOCAL original_res_addr :DWORD
  LOCAL original_res_size :DWORD
  
  LOCAL was_unpacked :DWORD
  
  ;Reserved stack space for future use
  LOCAL space[512 - 9 + 9 - 3 - 1] :DWORD
  
  ;Save loader state
  pushad
  pushfd

  ;IAT address
  lea ecx, IAT
  mov dword ptr [ecx], 11111111h
  
  ;Section virtual addresses
  lea ecx, sect_VA
  mov dword ptr [ecx], 22222222h
  mov dword ptr [ecx + 4], 22222222h
  mov dword ptr [ecx + 8], 22222222h
  mov dword ptr [ecx + 12], 22222222h
  mov dword ptr [ecx + 16], 22222222h
  mov dword ptr [ecx + 20], 22222222h
  mov dword ptr [ecx + 24], 22222222h
  mov dword ptr [ecx + 28], 22222222h
  mov dword ptr [ecx + 32], 22222222h
  mov dword ptr [ecx + 36], 22222222h
  mov dword ptr [ecx + 40], 22222222h
  mov dword ptr [ecx + 44], 22222222h
  mov dword ptr [ecx + 48], 22222222h
  mov dword ptr [ecx + 52], 22222222h
  mov dword ptr [ecx + 56], 22222222h
  mov dword ptr [ecx + 60], 22222222h
  
  ;Compressed sction sizes
  lea ecx, sect_size
  mov dword ptr [ecx], 33333333h
  mov dword ptr [ecx + 4], 33333333h
  mov dword ptr [ecx + 8], 33333333h
  mov dword ptr [ecx + 12], 33333333h
  mov dword ptr [ecx + 16], 33333333h
  mov dword ptr [ecx + 20], 33333333h
  mov dword ptr [ecx + 24], 33333333h
  mov dword ptr [ecx + 28], 33333333h
  mov dword ptr [ecx + 32], 33333333h
  mov dword ptr [ecx + 36], 33333333h
  mov dword ptr [ecx + 40], 33333333h
  mov dword ptr [ecx + 44], 33333333h
  mov dword ptr [ecx + 48], 33333333h
  mov dword ptr [ecx + 52], 33333333h
  mov dword ptr [ecx + 56], 33333333h
  mov dword ptr [ecx + 60], 33333333h
  
  ;Original section sizes
  lea ecx, sect_size_original
  mov dword ptr [ecx], 99999999h
  mov dword ptr [ecx + 4], 99999999h
  mov dword ptr [ecx + 8], 99999999h
  mov dword ptr [ecx + 12], 99999999h
  mov dword ptr [ecx + 16], 99999999h
  mov dword ptr [ecx + 20], 99999999h
  mov dword ptr [ecx + 24], 99999999h
  mov dword ptr [ecx + 28], 99999999h
  mov dword ptr [ecx + 32], 99999999h
  mov dword ptr [ecx + 36], 99999999h
  mov dword ptr [ecx + 40], 99999999h
  mov dword ptr [ecx + 44], 99999999h
  mov dword ptr [ecx + 48], 99999999h
  mov dword ptr [ecx + 52], 99999999h
  mov dword ptr [ecx + 56], 99999999h
  mov dword ptr [ecx + 60], 99999999h

  ;Original section attributes
  lea ecx, sect_attrs
  mov dword ptr [ecx], 44444444h
  mov dword ptr [ecx + 4], 44444444h
  mov dword ptr [ecx + 8], 44444444h
  mov dword ptr [ecx + 12], 44444444h
  mov dword ptr [ecx + 16], 44444444h
  mov dword ptr [ecx + 20], 44444444h
  mov dword ptr [ecx + 24], 44444444h
  mov dword ptr [ecx + 28], 44444444h
  mov dword ptr [ecx + 32], 44444444h
  mov dword ptr [ecx + 36], 44444444h
  mov dword ptr [ecx + 40], 44444444h
  mov dword ptr [ecx + 44], 44444444h
  mov dword ptr [ecx + 48], 44444444h
  mov dword ptr [ecx + 52], 44444444h
  mov dword ptr [ecx + 56], 44444444h
  mov dword ptr [ecx + 60], 44444444h
  
  ;Image base
  lea ecx, image_base
  mov dword ptr [ecx], 55555555h
  
  ;TLS index and original TLS index of PE file
  lea ecx, tls_index
  mov dword ptr [ecx], 66666666h
  lea ecx, tls_orig_index
  mov dword ptr [ecx], 77777777h
  
  lea ecx, fixup_table
  mov dword ptr [ecx], 0aaaaaaaah
  
  lea ecx, fixed_image_base
  mov dword ptr [ecx], 0cccccccch
  
  lea ecx, res_data_dir_addr
  mov dword ptr [ecx], 0ddddddddh
  
  lea ecx, original_res_addr
  mov dword ptr [ecx], 0eeeeeeeeh
  
  lea ecx, original_res_size
  mov dword ptr [ecx], 0ffffffffh
  
  call @F
    ;Global section variable used to determine if PE was unpacked
    dd 0h
  @@:
  pop eax
  mov was_unpacked, eax
  
  ;If already unpacked
  ;mov eax, fixed_image_base
  ;cmp byte ptr [eax + 28h], 0FFh
  cmp dword ptr [eax], 1
  jne @F
    mov eax, dword ptr [ebp + 4]
	sub eax, image_base
	add eax, fixed_image_base
	mov dword ptr [ebp + 4], eax
	;Load state
	popfd
	popad
	ret
  @@:
  
  
  mov original_image_base, 0
  
  ;Load API names to stack
  lea ecx, VirtualFreeName
  mov dword ptr [ecx], 'triV'
  mov dword ptr [ecx + 4], 'Flau'
  mov dword ptr [ecx + 8], 'eer'
  mov byte ptr [ecx + 11], 0
  
  lea ecx, VirtualAllocName
  mov dword ptr [ecx], 'triV'
  mov dword ptr [ecx + 4], 'Alau'
  mov dword ptr [ecx + 8], 'coll'
  mov dword ptr [ecx + 12], 0

  ;RtlDecompressBuffer
  lea ecx, RtlDecompressBufferName
  mov dword ptr [ecx], 'DltR'
  mov dword ptr [ecx + 4], 'moce'
  mov dword ptr [ecx + 8], 'serp'
  mov dword ptr [ecx + 12], 'fuBs'
  mov dword ptr [ecx + 16], 'ref'
  mov byte ptr [ecx + 19], 0

  lea ecx, ntdllName
  mov dword ptr [ecx], 'ldtn'
  mov dword ptr [ecx + 4], 'ld.l'
  mov dword ptr [ecx + 8], 'l'
  mov word ptr [ecx + 9], 0
  
  lea ecx, LoadLibraryAName
  mov dword ptr [ecx], 'daoL'
  mov dword ptr [ecx + 4], 'rbiL'
  mov dword ptr [ecx + 8], 'Ayra'
  mov byte ptr [ecx + 12], 0
  
  lea ecx, GetProcAddressName
  mov dword ptr [ecx], 'PteG'
  mov dword ptr [ecx + 4], 'Acor'
  mov dword ptr [ecx + 8], 'erdd'
  mov word ptr [ecx + 12], 'ss'
  mov word ptr [ecx + 14], 0
  
  lea ecx, VirtualProtectName
  mov dword ptr [ecx], 'triV'
  mov dword ptr [ecx + 4], 'Plau'
  mov dword ptr [ecx + 8], 'etor'
  mov word ptr [ecx + 12], 'tc'
  mov word ptr [ecx + 14], 0
  
  
  assume fs:nothing, gs:nothing
  
  ;Get kernel address from PEB
  mov eax, fs:[30h]
  mov eax, PEB.LoaderData[eax]
  mov eax, PEB_LDR_DATA.InLoadOrderModuleList[eax]
  mov eax, LDR_MODULE.InLoadOrderModuleList[eax]
  mov eax, LDR_MODULE.InLoadOrderModuleList[eax]
  mov eax, LDR_MODULE.BaseAddress[eax]
  mov edx, eax
  mov krnl, eax
  add eax, IMAGE_DOS_HEADER.e_lfanew
  mov eax, [eax]
  add eax, edx
  add eax, IMAGE_NT_HEADERS.OptionalHeader.DataDirectory.VirtualAddress
  mov eax, [eax]
  add eax, edx
  mov edi, eax

  ;Get export directory of kernel
  add eax, IMAGE_EXPORT_DIRECTORY.AddressOfNames
  mov eax, [eax]
  add eax, edx
  xor esi, esi

  ;Search "GetProcAddress"
  find:
    push eax
    mov eax, [eax]
    add eax, edx
    lea ebx, GetProcAddressName

    compare:
      mov cl, [eax]
      mov ch, [ebx]
      test cl, cl
      jz short test_ch
      test ch, ch
      jz short next
      jmp short check

      test_ch:
        test ch, ch
        jz short found
        jmp short next
		
      check:
        cmp cl, ch
        jne short short next
        inc eax
        inc ebx
        jmp short compare
		
    next:
      inc esi
      pop eax
      add eax, 4
      jmp short find
	  
found:
  ;Go to address of "GetProcAddress"
  pop eax
  mov eax, edi
  add eax, IMAGE_EXPORT_DIRECTORY.AddressOfNameOrdinals
  mov eax, [eax]
  add eax, edx
  add eax, esi
  add eax, esi
  mov bx, [eax]
  movzx ebx, bx
  mov eax, edi
  add eax, IMAGE_EXPORT_DIRECTORY.AddressOfFunctions
  mov eax, [eax]
  add eax, edx
  add ebx, ebx
  add eax, ebx
  add eax, ebx
  mov eax, [eax]
  add eax, edx
  mov GetProcAddressFunc, eax
  
  ;Now get "LoadLibraryA" address
  lea eax, LoadLibraryAName
  xinvoke GetProcAddressFunc, krnl, eax
  mov LoadLibraryAFunc, eax
  
  ;We need also VirtualAlloc, VirtualProtect, VirtualFree addresses
  lea eax, VirtualAllocName
  xinvoke GetProcAddressFunc, krnl, eax
  mov VirtualAllocFunc, eax

  lea eax, VirtualProtectName
  xinvoke GetProcAddressFunc, krnl, eax
  mov VirtualProtectFunc, eax

  lea eax, VirtualFreeName
  xinvoke GetProcAddressFunc, krnl, eax
  mov VirtualFreeFunc, eax
  
  ;Load ntdll library
  lea eax, ntdllName
  xinvoke LoadLibraryAFunc, eax
  mov ntdll, eax
  
  lea eax, RtlDecompressBufferName
  xinvoke GetProcAddressFunc, ntdll, eax
  mov RtlDecompressBufferFunc, eax
  

  ;Check if we need to apply fixups
  mov eax, fixed_image_base
  mov ebx, image_base
  cmp eax, ebx
  je @F
    mov edi, eax
	mov original_image_base, ebx
	
    lea esi, sect_VA
	
    fixup:
	  ; += ((DWORD) pBaseAddress - (DWORD)pPreferAddress)
	  mov eax, [esi]
	  sub eax, image_base
	  add eax, edi
	
	  mov [esi], eax
	  
      add esi, 4
      cmp dword ptr [esi], 0
    jne short fixup


	mov eax, image_base
	
	sub IAT, eax
	add IAT, edi
	
	.if tls_index != 0
	  sub tls_index, eax
	  add tls_index, edi
	  sub tls_orig_index, eax
	  add tls_orig_index, edi
	.endif
	
	;sub fixup_table, eax
	add fixup_table, edi
	
	mov image_base, edi
  @@:
  
  
  ;Decompress sectios
  lea esi, sect_VA
  lea edi, sect_size
  lea ebx, sect_size_original

  unpacker:
    xinvoke VirtualAllocFunc, 0, [ebx], MEM_COMMIT, PAGE_READWRITE
    mov tempbuf, eax

	push ebx
	
	
    lea eax, tempparam ;PULONG FinalUncompressedSize
    push eax
    push [edi] ;ULONG CompressedBufferSize
    push [esi] ;PUCHAR CompressedBuffer
	push [ebx] ;ULONG UncompressedBufferSize
    push tempbuf ;PUCHAR UncompressedBuffer
    push COMPRESSION_FORMAT_LZNT1 ;USHORT CompressionFormat
	
    call RtlDecompressBufferFunc
	
	pop ebx

    push esi
    push edi
	
	;Copy uncompressed memory to its section address
	mov	edi, [esi]
	mov	esi, tempbuf
	
	cld
	mov	ecx, tempparam
	rep	movsb
	
    pop edi
    pop esi
	
	xinvoke VirtualFreeFunc, tempbuf, 0, MEM_RELEASE

    add esi, 4
    add edi, 4
    add ebx, 4
    cmp dword ptr [esi], 0
  jne short unpacker
  
  
  ;Fix imports
  mov esi, IAT
  test esi, esi
  jz end_imports
  
  import_next:
    mov ecx, [esi + IMAGE_IMPORT_DESCRIPTOR.Name1]
    test ecx, ecx
    je short end_imports

    add ecx, image_base
    xinvoke LoadLibraryAFunc, ecx
    mov edi, eax
	
	mov ebx, [esi + IMAGE_IMPORT_DESCRIPTOR.OriginalFirstThunk]
    test ebx, ebx
    jne short @F
      mov ebx, [esi + IMAGE_IMPORT_DESCRIPTOR.FirstThunk]
    @@:
    add ebx, image_base

    mov ecx, [esi + IMAGE_IMPORT_DESCRIPTOR.FirstThunk]
    add ecx, image_base

    next_function:
      mov eax, [ecx]
      test eax, eax
      je short end_library

      mov eax, [ebx]
      and eax, 80000000h
      jne short by_ordinal
	  
      ;Import by name
      push ecx
      mov eax, [ebx]
      add eax, image_base
      add eax, 2h
      xinvoke GetProcAddressFunc, edi, eax
      pop ecx
      jmp short getaddr_end

      by_ordinal:
      ;Import by ordinal

      push ecx
      mov eax, [ebx]
      and eax, 0ffffh
      xinvoke GetProcAddressFunc, edi, eax
      pop ecx

      getaddr_end:

      ;eax - func address
      mov [ecx],eax

      add ecx, 4
      add ebx, 4

      ;ecx - lookup
      ;ebx - address

    jmp short next_function
	
    end_library:

    add esi, sizeof IMAGE_IMPORT_DESCRIPTOR
    jmp import_next

  end_imports:


  ;TLS fix
  cmp tls_index,0
  je short @F
    mov eax, tls_index
    mov ecx, tls_orig_index
    m2m [ecx], [eax] ;Copy index value to original index location
  @@:
  
  
  
  ;If fixups are present
  .if original_image_base != 0
    mov esi, fixup_table
	
	apply_fixups:
	  mov eax, [esi + 4] ;blockSize
	  test eax, eax
	  jz end_fixups
	  cmp eax, 8 ;sizeof fixup entry
	  je end_fixups
	  
	  mov ecx, 8
	  
	  apply_table:
	    movzx ebx, word ptr [esi + ecx]
		shr ebx, 12 ;typeX = (*(WORD*)(pReloc + a)) >> 12
		
		.if ebx == 3
		  movzx ebx, word ptr [esi + ecx]
		  and ebx, 4095 ;offsetX = (*(WORD*)(pReloc + a)) & ((1 << 12) - 1)
		  
		  mov edx, [esi]
		  add edx, image_base
		  add edx, ebx
		  
		  mov edi, [edx]
		  sub edi, original_image_base
		  add edi, image_base
		  mov [edx], edi
		.endif
		
	    add ecx, 2
	    .if ecx < eax
		  jmp apply_table
	    .endif
		
		add esi, eax; += blockSize
	    jmp apply_fixups
	end_fixups:
	
  .endif
  
  
  ;Fix section attributes
  lea eax, old_prot
  ;Temporarily make attributes area read-write
  xinvoke VirtualProtectFunc, image_base, 200h, PAGE_READWRITE, eax

  lea esi, sect_attrs

  mov edi, image_base
  add edi, IMAGE_DOS_HEADER.e_lfanew
  mov edi, [edi]

  mov ecx, edi
  add ecx, IMAGE_NT_HEADERS.FileHeader.SizeOfOptionalHeader
  add ecx, image_base
  xor eax, eax
  mov ax, word ptr [ecx]
  add edi, eax

  add edi, sizeof IMAGE_NT_HEADERS.FileHeader
  add edi, sizeof IMAGE_NT_HEADERS.Signature
  add edi, image_base

  add edi, IMAGE_SECTION_HEADER.Characteristics

  sect_fixer:
    m2m [edi], [esi]
    add esi, 4
    add edi, sizeof IMAGE_SECTION_HEADER
    cmp dword ptr [esi], 0
  jne short sect_fixer
  
  
  ;If fixups are present
  .if original_image_base != 0
	mov eax, dword ptr [ebp + 4]
	sub eax, original_image_base
	add eax, image_base
	mov dword ptr [ebp + 4], eax
  .endif
  
  ;Save info telling file is already unpacked
  ;mov eax, fixed_image_base
  ;mov byte ptr [eax + 28h], 0FFh
  mov eax, was_unpacked
  mov dword ptr [eax], 1
  
  ;Don't forget to restore resource section
  .if res_data_dir_addr != 0
    mov eax, res_data_dir_addr
	add eax, image_base
	mov edx, original_res_addr
	mov [eax], edx
	mov edx, original_res_size
	mov [eax + 4], edx
  .endif
  
  
  ;Restore image header memory attributes
  lea eax, old_prot
  xinvoke VirtualProtectFunc, image_base, 200h, old_prot, eax
  
  
  ;Load loader state
  popfd
  popad
  ;Go to original entry point, balancing the stack
ret
mainfunc ENDP

end start